unit FoAblak;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ExtCtrls;

type

  { TfmSzovKer }

  TfmSzovKer = class(TForm)
    bbVege: TBitBtn;
    btTovabbBM: TButton;
    btKeressKMP: TButton;
    btKeressBM: TButton;
    btTovabbKMP: TButton;
    btBe: TButton;
    edMinta: TEdit;
    lbHasDbKMP: TLabel;
    lbHasDbBM: TLabel;
    lbKMP: TLabel;
    lbCim: TLabel;
    lbBM: TLabel;
    lbMinta: TLabel;
    mmKMP: TMemo;
    mmBM: TMemo;
    odBe: TOpenDialog;
    tmVarakozas: TTimer;
    procedure btBeClick(Sender: TObject);
    procedure btKeressBMClick(Sender: TObject);
    procedure btKeressKMPClick(Sender: TObject);
    procedure btTovabbBMClick(Sender: TObject);
    procedure btTovabbKMPClick(Sender: TObject);
    procedure edMintaChange(Sender: TObject);
    procedure mmBMChange(Sender: TObject);
    procedure mmKMPChange(Sender: TObject);
    procedure tmVarakozasTimer(Sender: TObject);
    procedure Delay(const ms:integer);
    procedure memobanKijelol(mm:TMemo; const tol,db:integer);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmSzovKer: TfmSzovKer;

  //a keress nyomkvetsnek megszervezshez:
  sorbanHolKMP,
  sorbanHolBM,
  sor:integer;
  eltolasKMP:array [1..256] of byte;
  eltolasBM :array [Char] of byte;
  //a keress kirtkelshez:
  hasDbKMP,
  hasDbBM:integer;
const
  DbCimke='Hasonltsszm: ';
  Cr=#13;
  Lf=#10;
  varIdo=100;

implementation

{ TfmSzovKer }

uses
  SzovKer;
  
procedure TfmSzovKer.Delay(const ms:integer);
  var i:integer;
begin
  for i:=1 to 10000*ms do eltolasKMP:=eltolasKMP; //egy idignyes tevkenysg
  application.ProcessMessages;//az egyb komponensek frisstshez...
end;//Delay

procedure TfmSzovKer.tmVarakozasTimer(Sender: TObject);

begin
  Delay(1000);
end;//tmVarakozasTimer

procedure TfmSzovKer.memobanKijelol(mm:TMemo; const tol,db:integer);
begin
  with mm do
  begin
    SetFocus; SelStart:=tol-1; SelLength:=db;
  end;//with
end;//memobanKijelol

//Knuth-Morris-Pratt:

procedure TfmSzovKer.btKeressKMPClick(Sender: TObject);
begin
  //keress ellrl:
  with fmSzovKer do
  begin
    eltolasGeneralasKMP(edMinta.Text);
    hasDbKMP:=0;
    sorbanHolKMP:=1;
    KeresKMP(mmKMP,edMinta.Text);
    btTovabbKMP.Enabled:=True
  end;//with
end;//btKeressKMPClick

procedure TfmSzovKer.btTovabbKMPClick(Sender: TObject);
begin
  //keress folytatlag:
  KeresKMP(mmKMP,edMinta.Text);
end;//btTovabbKMPClick

//Boyer-Moore:

procedure TfmSzovKer.btKeressBMClick(Sender: TObject);
begin
  //keress ellrl:
  with fmSzovKer do
  begin
    eltolasGeneralasBM(edMinta.Text);
    hasDbBM:=0;
    sorbanHolBM:=length(edMinta.Text);
    KeresBM(mmBM,edMinta.Text);
    btTovabbBM.Enabled:=True
  end;//with
end;//btKeressBMClick

procedure TfmSzovKer.btTovabbBMClick(Sender: TObject);
begin
  //keress folytatlag:
  KeresBM(mmBM,edMinta.Text);
end;//btTovabbBMClick

//Minden egyb:

procedure TfmSzovKer.edMintaChange(Sender: TObject);
begin
  btTovabbKMP.Enabled:=False;
  btTovabbBM.Enabled:=False;
end;//edMintaChange

procedure TfmSzovKer.mmBMChange(Sender: TObject);
begin
  btTovabbBM.Enabled:=False
end;

procedure TfmSzovKer.mmKMPChange(Sender: TObject);
begin
  btTovabbKMP.Enabled:=False
end;

procedure TfmSzovKer.btBeClick(Sender: TObject);
  var
    beFN:string;
begin
  if odBe.execute then
  begin
    beFN:=odBe.FileName;
    mmKMP.Lines.LoadFromFile(beFN);
    mmBM.Text:=mmKMP.Text;
    btTovabbKMP.Enabled:=False;
    btTovabbBM.Enabled:=False;
  end
    else
  begin
    ShowMessage('A fjlmegnyits sikertelen.');
  end;
end;//btBeClick

initialization
  {$I FoAblak.lrs}

end.

